#ifndef _OOCLIP_CH
#define _OOCLIP_CH

#define B_SINGLE 1
#define B_DOUBLE 2
#define GETADDRESS(xfunc) xfunc(__getaddr())

#define _OGETCLASS(x) __ClassIns(x)
#xtranslate __thefirstone(<x>) => <x>
#xtranslate __thefirstone(<x> <y>) => <x>

#command CREATE CLASS <name> [ALIAS <aliasName>] [ FROM <parent>] => ;
  CLASS <name> [ALIAS <aliasName>] [ FROM <parent> ]

#xtranslate PARENTNO(<x>) => <x>(.t.)
#xtranslate PARENTNO()  => 0

#command CLASS [STATIC] <name> [ALIAS <aliasName>] [ FROM <parent> ] => ;
[STATIC] FUNCTION <name>(__lHasParent);;
static nposition;;
local cClassname,nparentno,alias,avars,amethods;;
if nPosition==nil;;
   cClassname:=upper(<"name">);;
   nparentno:=PARENTNO(<parent>);;
   alias:=__thefirstone(<"aliasName"> cClassname);;
   avars:={};;
   amethods:={}

#command SCHOCLASS <name> [NAME <classname>]=> ;
FUNCTION <name>();;
local cClassname:=upper(__thefirstone(<"classname"> <"name">)),amethods:={};;

#command SCHOCLASS STATIC <name> [NAME <classname>] => ;
STATIC FUNCTION <name>();;
local cClassname:=upper(__thefirstone(<"classname"> <"name">)),amethods:={};;


#xcommand VAR <var1> [,<varN>] => ;
          AAdd(aVars,<"var1">) [; VAR <varN>]

#xcommand METHOD <methodName> BLOCK <block> => ;
        AAdd(aMethods,{<"methodName">, <block>})

#xcommand METHOD <methodName> [,<*methodN*>] => ;
        AAdd(aMethods,{<"methodName">, <methodName>(__getaddr())}) [; METHOD <methodN>]

#xcommand METHOD <methodName> = <methodUDF> [,<*methodN*>] => ;
        AAdd(aMethods,{<"methodName">, <methodUDF>(__getaddr())}) [; METHOD <methodN>]

#xcommand METHOD <methodName> := <methodUDF> [,<*methodN*>] => ;
        AAdd(aMethods,{<"methodName">, <methodUDF>(__getaddr())}) [; METHOD <methodN>]

#xcommand END CLASS => ENDCLASS

#xcommand ENDCLASS => ;
          nposition:=_oMakeClass(cClassname,aVars,aMethods,nparentno,alias);;
    end;;
    if  empty(__lHasparent);;
        retu _OGETCLASS(nposition);;
    end;;
    retu nPosition
#xcommand ENDMETA => ;
          nposition:=_OGETCLASS(_oMakeClass(cClassname,aVars,aMethods,nparentno,alias));;
    end;;
    if  empty(__lHasparent);;
        retu nposition;;
    end;;
    retu nPosition:classh

#xcommand ENDSCHL    <x> => ENDSCHOLOR <x>
#xcommand ENDSCHOLOR <x> => ;
    retu _regschl(<x>,_oMakeClass(cClassname,{},aMethods,0,''))

#command METHOD FUNCTION <name> [;<*Any*>] => static FUNCTION <name>() ;;
                LOCAL Self:=QSELF() [;<Any>]
#command METHOD FUNCTION <name> ([<list,...>]) [;<*Any*>] => static FUNCTION <name>([<list>]) ;;
                LOCAL Self:=QSELF() [;<Any>]

#xtranslate :: => self:

#endif
