#include "OoClip.ch"

ANNOUNCE CLASSINIT

STATIC   aClasses:={}

*------------------------------------------*
FUNCTION _oMakeClass(cClassname,aVars,aMs,np,alias)
*------------------------------------------*
local k,i,j,atree:={},nr:=0,nhandle,cvar,s

k:=len(avars)
i:=np
do while np>0
   k+=len(aclasses[np,2])
   np:=aclasses[np,1]
enddo
nHandle := __ClassNew(cClassname,k)
aclasses:=asize(aclasses,nHandle)
aclasses[nHandle]:={i,avars,aMs,alias}

j:=0
np:=nHandle

do while np>0
   k:=len(avars:=aclasses[np,2])
   for i:=1 to k
       cVar := aVars[i]
       __ClassAdd(nHandle,cVar,++j)
       __ClassAdd(nHandle,"_"+cVar,++j)
   NEXT
   k:=len(aMs:=aclasses[np,3])
   for i:=1 to k
       cVar := aMs[i,1]
       nr:=0
       if ascan(atree,cvar)>0
          cvar:=aclasses[np,4]+cvar
       endif
       aadd(atree,cvar)
       __ClassAdd(nHandle,cVar,aMs[i,2])
   NEXT
   np:=aclasses[np,1]
enddo
retu nhandle

#ifndef _OGETCLASS

*------------------------------------------*
function _oGetClass(np)
*------------------------------------------*
retu __ClassIns(np)

#endif
************************************************************
* Next is Scholor classes
************************************************************


#define  HDCR  CHR(13)+CHR(10)


INIT PROC SCHLINIT
numeric()
character()
nnil()
logical()
aarray()
block()
ddate()


SCHOCLASS STATIC NUMERIC
       method size=numsize
       method asstring=numasstring
       method asliteral=numasliteral
       method eval=__exec
ENDSCHL 0

METHOD FUNC numsize
retu len(str(self))

METHOD FUNC numasstring
retu str(self)

METHOD FUNC numasliteral
retu alltrim(str(self))

*---------------------------------------------------*
*---------------------------------------------------*

SCHOCLASS STATIC CHARACTER
       method size=chrsize
       method asstring=chrasstring
       method asliteral=chrasliteral
ENDSCHL 'A'

METHOD FUNC chrsize
retu len(self)

METHOD FUNC chrasstring
retu self

METHOD FUNC chrasliteral
if !'"'$self
   retu '"'+self+'"'
elseif !"'"$self
   retu "'"+self+"'"
elseif !']'$self
   retu "["+self+"]"
endif
retu ''

*---------------------------------------------------*
*---------------------------------------------------*
SCHOCLASS STATIC DDATE name date
       method size=datesize
       method asstring=dateasstring
       method asliteral=dateasliteral
ENDSCHL date()

METHOD FUNC datesize
retu 8

METHOD FUNC dateasstring
retu dtoc(self)

METHOD FUNC dateasliteral
retu 'ctod('+dtoc(self)+')'

*---------------------------------------------------*
*---------------------------------------------------*
SCHOCLASS STATIC LOGICAL
       method size=lsize
       method asstring=lasstring
       method asliteral=lasstring
ENDSCHL .t.

METHOD FUNC lsize
retu 3

METHOD FUNC lasstring()
retu if(self,'.t.','.f.')

*---------------------------------------------------*
*---------------------------------------------------*
SCHOCLASS STATIC BLOCK
       method size=bsize
       method asstring=basstring
       method eval=__ixblock
ENDSCHL {||.t.}

METHOD FUNC bsize()
retu ::eval:size

METHOD FUNC basstring()
retu ::eval:asstring

*---------------------------------------------------*
*---------------------------------------------------*
SCHOCLASS STATIC NNIL name nil
       method size=nilsize
       method asstring=nilasstring
       method asliteral=nilasstring
ENDSCHL nil

METHOD FUNC nilsize
retu 3

METHOD FUNC nilasstring
retu 'NIL'

*---------------------------------------------------*
*---------------------------------------------------*
SCHOCLASS STATIC AARRAY name array
       method size=chrsize
       method asstring=arrasstring
       method asliteral=arrasliteral
       method classinfo
       method varname
       method varvalue
       method doit
       method superhandle
       method makesuper
       method changemethod
       method classname=_anyclassn
       method classh=_anyclassh
       method varinfo
ENDSCHL {}

METHOD FUNC arrasstring(cDeli)
local cResult:=''
if cDeli==nil
   cDeli:=' '
endif
aeval(self,{|_1|cResult+=' '+_1:asstring})
retu substr(cResult,2)

METHOD FUNC arrasliteral
local cResult:=''
aeval(self,{|_1|cResult+=','+_1:asliteral})
retu '{'+substr(cResult,2)+'}'

*-----------------------*
METHOD FUNC ClassInfo
*-----------------------*
LOCAL nPos, cClass, cSuper:="",nsuper,o
   npos:=::classh
   cClass:=::classname
   nsuper:=::superhandle
   IF  nsuper>0
       csuper:=_OGETCLASS(nsuper):classinfo:classname
   ENDIF
   OutStd(HDCR)
   OutStd("//"+PADC(" FastClass for Clipper Version 1.0 ",60,"-")+HDCR)
   OutStd("CLASS "+cClass+" ALIAS "+aclasses[npos,4]+IF(EMPTY(cSuper),""," FROM "+cSuper)+HDCR)
   OutStd("//"+PADC(" Class Variable ( "+LTRIM(STR(LEN(aclasses[npos,2])))+" ) ",60,"-")+HDCR)
   AEVAL(aclasses[npos,2],{|v|OutStd(SPACE(4)+"VAR",v,HDCR)})
   OutStd("//"+PADC(" Class Method ( "+LTRIM(STR(LEN(aclasses[npos,3])))+" ) ",60,"-")+HDCR)
   AEVAL(aclasses[npos,3],{|_1|OutStd(SPACE(4)+"METHOD "+PAD(_1[1],20)+" = "+pad(_1[2],20)+HDCR)})
   OutStd(HDCR)
   OutStd("ENDCLASS"+HDCR)
   OutStd(HDCR)
RETURN Self

method func varinfo
local i:=0
aeval(self,{|_1|i++,qout(padr(::varname(i),20),'=',self[i])})
retu self

METHOD FUNC VARNAME(number)
local a:=aclasses[self:classh]
do while len(a[2])<number.and.a[1]>0
   number-=len(a[2])
   a:=aclasses[a[1]]
enddo
if number<=len(a[2])
   retu a[2,number]
endif
retu ''

METHOD FUNC VARVALUE(name)
local a:=aclasses[self:classh],i,j:=0
name:=upper(name)
do while (i:=ascan(a[2],name))==0.and.a[1]>0
   j+=len(a[2])
   a:=aclasses[a[1]]
enddo
if i>0
   retu self[i+j]
endif
retu nil

METHOD FUNC DOIT
retu self

METHOD FUNC SUPERHANDLE(i)
local handle:=::classh
if i==nil
   i:=1
endif
do while i-- >0.and.handle>0
   handle:=aclasses[handle,1]
enddo
retu handle

METHOD FUNC MAKESUPER
retu _OGETCLASS(::superhandle)

METHOD FUNC CHANGEMETHOD(name,address)
local ams,i,calias,handle:=::classh,atree:={},l,cvar
name:=upper(name)
calias:=upper(aclasses[handle,4])
if !empty(address)
   __classadd(::classh,name,address)
endif
do while handle>0
   l:=len(ams:=aclasses[handle,3])
   calias:=aclasses[handle,4]
   for i:=1 to l
       if name==ams[i,1].or.name==calias+ams[i,1]
          retu ams[i,2]
       endif
    next
    handle:=aclasses[handle,1]
enddo
retu 0
